Subject: Re: [Idr] 6PE-Alt draft

From: "Vishwas Manral" <[email-masked]>
Date: Thu, 31 Jan 2008 06:31:27 -0800

Hi Jan,

You may be missing the scope of the document. There is a discussion in
the v6ops group too which .

The idea is simple. We do not need to define a new AFI/ SAFI
combination to achieve the 6PE functionality. We can just use the
meaning implied in the IPv6 Explicit NULL label. The 6PE RFC does talk
about allowing signaling for the Explicit NULL label in which case the
dataplane functionality becomes just the same, but in 6PE even that is
signaled using BGP extensions defined in RFC3107.

Thanks,
Vishwas

On Jan 31, 2008 2:14 AM, Jan Novak <[email-masked]> wrote:
>
>
> Hi,
>
> Just out of curiosity - lets say you have two IPv4 VPNs with
> overlapping set of Pes and both of them want to provide 6PE
> service.
> When the explicit-null encapsulated packets from two different
> VPNs (but same PE) arrive to the other side PE - how do you
> decide which is which - e.g. which packet should be shipped to
> which VPN ??
>
> Jan
>
>
> _________________________________________________________________
> Telly addicts unite!
> http://www.searchgamesbox.com/tvtown.shtml

_______________________________________________
Idr mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/idr

---

From: "Vishwas Manral" <[email-masked]>
Date: Thu, 31 Jan 2008 07:00:51 -0800

Hi Jan,

I am CC'ing the authors of the 6PE draft to get their views. Let me
explain the draft in greater detail however.

In 6PE, MP-BGP SAFI family label is used to exchange routes between 2
6PE routers (a new AFI/ SAFI combination is defined). Each route is
attached with a label (which may be the IPv6 Explicit NULL label). In
the data-plane this label is used as the inner label and the other
label is the tunnel label, which gets the packet from source PE to
destination PE. Once the packet gets to the destination PE, the inner
label is looked up and a POP operation is done on it and the IPv6
header is looked up in the routing table.

With 6PE-Alt, no additional signaling mechanism is required. All we
need to do is instead of using the signaled label as the inner label,
we use the IPv6 Explicit NULL label. The same operations happen as 6PE
without any explicit signaling of the labels with each route. It helps
prevent all the excess signaling and still providing the exact same
functionality. We are using the meaning implied in the "Explicit NULL
Label". We do not need to signal anything here.

As an alternate, if you notice in IPv6, the end sites/ devices will
become IPv6 and the network may still have IPv4. If the assumption
that each device in the IPv6 networks has a Global IPv6 address (not
that IPv6 site local has been deprecated), we can do without the
entire BGP MPLS IPv6 VPN functionality.

Thanks,
Vishwas

---

From: Francois Le Faucheur IMAP <[email-masked]>
Date: Thu, 31 Jan 2008 17:56:18 +0100

Hi,

FYI, here is a note posted on the v6ops list where that topic was  
brought up first by Vishwas.

Begin forwarded message:
> From: Francois Le Faucheur IMAP <[email-masked]>
> Date: 31 January 2008 17:53:54 GMT+01:00
> To: Vishwas Manral <[email-masked]>
> Cc: Francois Le Faucheur IMAP <[email-masked]>,  
> [email-masked], "Jeremy De Clercq" <jeremy.de_clercq@alcatel- 
> lucent.be>, "Ooms Dirk" <[email-masked]>, [email-masked]
> Subject: Re: 6PE-Alt
>
>
> On 31 Jan 2008, at 15:25, Vishwas Manral wrote:
>
>> Hi Francois,
>>
>> The document I have written does not use signaling
>
> It is a bit of a stretch to claim that 6PE-Alt does not use signaling.
> 6PE-Alt and 6PE both use MP-BGP to signal IPv6 reachability.  6PE- 
> Alt would simply save you one field (the label value) inside the  
> same advertisement.
>
> On the other hand, 6PE-Alt would restrict operations to only one of  
> the options allowed in 6PE. The reasons 6PE allowed multiple label  
> allocation is precisely because different PEs may want to use  
> different label allocation policies.  For example, one 6PE router  
> may prefer to allocate per-prefix label in order to be able to  
> forward packets via label switching as opposed to performing IPv6  
> lookup. 6PE allows each PR router to use whatever label allocation  
> scheme it sees best.
>
>
>> and does not define
>> a new AFI/SAFI functionality to achieve the 6PE.
>
> It is a bit of a stretch to imply that 6PE defines a new AFI/SAFI.
> 6PE uses the IPv6 AFI and the SAFI defined in RFC3107 (which for  
> memory dates back from 2001) precisely for the purpose of binding  
> an MPLS label when advertising IPv6 reachability.
>
>>
>> The difference is obvious, we get the same functionality
>
> my impression is that you get a restricted subset of the  
> functionality (ie forcing every router to use that single label  
> allocation scheme). This had been discussed before and decided that  
> such a restriction was undesirable and unnecessary.
>
>> without
>> adding any new signaling mechanism.
>
> my impression is that both use the same MP-BGP signaling mechanism  
> except one would save a few bytes in the same MP-BGP advertisements.
>
> There are multiple interoperable implementations of 6PE today and  
> am not aware of significant issues with the current 6PE control plane.
>
> Cheers
>
> Francois
>

---

From: Francois Le Faucheur IMAP <[email-masked]>
Date: Thu, 31 Jan 2008 18:05:54 +0100

Hi Jan,

There are two documents that relate to transport of IPv6 over an IPv4  
MPLS core:
	* RFC4659 (6VPE): IPv6 VPNS over (say) IPv4 MPLS
	* RFC4798 (6PE): IPv6 over IPv4 MPLS

The quote below is from the 6PE RFC (ie WITHOUT VPN/VRF). It does not  
apply to the 6VPE.

Francois

On 31 Jan 2008, at 18:00, Jan Novak wrote:

>
>
>
> Hi Vishwas,
>
> I believe you refer to this part of 6PE spec:
>
>    The label bound by MP-BGP to the IPv6 prefix indicates to the  
> egress
>    6PE Router that the packet is an IPv6 packet.  This label  
> advertised
>    by the egress 6PE Router with MP-BGP MAY be an arbitrary label  
> value,
>    which identifies an IPv6 routing context or outgoing interface to
>    send the packet to, or MAY be the IPv6 Explicit Null Label.  An
>    ingress 6PE Router MUST be able to accept any such advertised  
> label.
>
> I don't know what is the envisaged use of Explicit Null here - but  
> I would think
> it is for some other purposes since to deliver the packet to the  
> VPN this is
> still needed "identifies an IPv6 routing context or outgoing  
> interface to".
>
> Jan
>
>
>
>
> Share what Santa brought you
> https://www.mycooluncool.com

---

From: "Vishwas Manral" <[email-masked]>
Date: Thu, 31 Jan 2008 09:23:42 -0800

Hi Francois,

As the 6PE-Alt does not require any additional functionality from
BGP-IPv6 (yes that is the signaling required - but that is the same
required for normal BGP IPv6. For 6PE we use a new AFI/ SAFI and send
labels uselessly. So please do not say that the claim no signaling
changes are required for 6PE-Alt  is a stretch), and that is why we
have inter-operable implementations of 6PE-Alt too. It is not about
interoperable implmentations alone though. I however am surprised how
this simple mechanism was not captured earlier in the review or coding
process.

We do not need to transport labels at all which are now being
transported. Also as the peer decides the label I use, we may have to
configure different labels from different peers (thus using bigger
keys/ more memory in the tables and a lot of other overload). There is
a lot of overhead of signaling and dataplane without any necessity.

I also have issues with the 6VPE RFC too but let us tackle issues one at a time.

Thanks,
Vishwas

On Jan 31, 2008 8:56 AM, Francois Le Faucheur IMAP <[email-masked]> wrote:
>
> Hi,
>
> FYI, here is a note posted on the v6ops list where that topic was brought up
> first by Vishwas.
>
>
>
> Begin forwarded message:
> Cc: Francois Le Faucheur IMAP <[email-masked]>, [email-masked],
> "Jeremy De Clercq" <[email-masked]>, "Ooms Dirk"
> <[email-masked]>, [email-masked]
> Subject: Re: 6PE-Alt
>
>
> 6PE-Alt and 6PE both use MP-BGP to signal IPv6 reachability.  6PE-Alt would
> simply save you one field (the label value) inside the same advertisement.
>
> On the other hand, 6PE-Alt would restrict operations to only one of the
> options allowed in 6PE. The reasons 6PE allowed multiple label allocation is
> precisely because different PEs may want to use different label allocation
> policies.  For example, one 6PE router may prefer to allocate per-prefix
> label in order to be able to forward packets via label switching as opposed
> to performing IPv6 lookup. 6PE allows each PR router to use whatever label
> allocation scheme it sees best.
>
>
>
> and does not define
> 6PE uses the IPv6 AFI and the SAFI defined in RFC3107 (which for memory
> dates back from 2001) precisely for the purpose of binding an MPLS label
> when advertising IPv6 reachability.
>
>
>
> my impression is that you get a restricted subset of the functionality (ie
> forcing every router to use that single label allocation scheme). This had
> been discussed before and decided that such a restriction was undesirable
> and unnecessary.
>
>
> without
> my impression is that both use the same MP-BGP signaling mechanism except
> one would save a few bytes in the same MP-BGP advertisements.
>
> There are multiple interoperable implementations of 6PE today and am not
> aware of significant issues with the current 6PE control plane.
>
> Cheers
>
> Francois
>
>
>
>
>
>

---

From: "Vishwas Manral" <[email-masked]>
Date: Thu, 31 Jan 2008 09:32:01 -0800

Hi Jan,

Unlike in BGP MPLS IP VPN, the label does not tell any interface as we
finally look up the only routing table the IPv6 routing table. We do
not have the VRF concept here. That is the reason we do not need any
presignaled label. The 6PE draft mentions why we need the top label
very clearly.

However they have wrongly decided to signal a label with each route
instead of just using the IPv6 Explicit NULL label.

Thanks,
Vishwas

On Jan 31, 2008 9:00 AM, Jan Novak <[email-masked]> wrote:
>    The label bound by MP-BGP to the IPv6 prefix indicates to the egress
>    6PE Router that the packet is an IPv6 packet.  This label advertised
>    by the egress 6PE Router with MP-BGP MAY be an arbitrary label value,
>    ingress 6PE Router MUST be able to accept any such advertised label.
>
> I don't know what is the envisaged use of Explicit Null here - but I would think
> it is for some other purposes since to deliver the packet to the VPN this is
> still needed "identifies an IPv6 routing context or outgoing interface to".
>
> Jan
>
>
>
>

---

From: "Vishwas Manral" <[email-masked]>
Date: Thu, 31 Jan 2008 11:31:14 -0800

Forwarding Francois reply and my subsequent reply on the v6ops list,
to this list.

Thanks,
Vishwas
====================================================================
Hi Francois,

Thanks a lot for the reply.

It seems the only thing the 6PE RFC does is that it allows different
label allocation policies (for different routes), when no label
allocation is required at all.

If you think people will still use the 6PE approach even when they can
achieve the same without any new signaling extensions (a new AFI/SAFI
pair) then I am fine to position the draft as an option to your draft.
Do let me know if you feel that way?

Thanks,
Vishwas
- Hide quoted text -

On Jan 31, 2008 11:00 AM, Francois Le Faucheur IMAP <[email-masked]> wrote:
> Hi Vishwas,
>
> I think I've brought up my main points in the previous message so
> will leave it at that for now.
>
> On 31 Jan 2008, at 18:29, Vishwas Manral wrote:
>
> > Hi Francois,
> >
> > interoperable implementations alone though. I however am surprised how
> > I also have issues with the 6VPE RFC too but let us tackle issues one
> > at a time. Also please note 6VPE has the concept of VRF's and is used
> > to give VPN services, while VPE is used for basic IPv6 connectivity
> > over MPLS IPv4 coulds. So please do not confuse the 2.
>
> I didn't really feel confused about the 2, but thanks for the advise ^)
>
> Cheers
>
> Francois
>
>
> >
> > Thanks,
> > Vishwas
> >
> > On Jan 31, 2008 8:53 AM, Francois Le Faucheur IMAP
> > <[email-masked]> wrote:
> >>
> >> 6PE-Alt and 6PE both use MP-BGP to signal IPv6 reachability.  6PE-Alt
> >> would simply save you one field (the label value) inside the same
> >> advertisement.
> >>
> >> different label allocation policies.  For example, one 6PE router may
> >> prefer to allocate per-prefix label in order to be able to forward
> >> packets via label switching as opposed to performing IPv6 lookup. 6PE
> >> allows each PR router to use whatever label allocation scheme it sees
> >> best.
> >>
> >>
> >>> and does not define
> >> memory dates back from 2001) precisely for the purpose of binding an
> >> MPLS label when advertising IPv6 reachability.
> >>
> >>>
> >> There are multiple interoperable implementations of 6PE today and am
> >> not aware of significant issues with the current 6PE control plane.
> >>
> >> Cheers
> >>
> >> Francois
> >>
>
>